__revision__ = "/home/scons/scons/branch.0/branch.96/baseline/src/engine/SCons/SConsign.py 0.96.91.D001 2005/09/08 09:14:36 knight"
import cPickle
import os
import os.path
import string
import time
import SCons.dblite
import SCons.Sig
import SCons.Warnings
def corrupt_dblite_warning(filename):
    SCons.Warnings.warn(SCons.Warnings.CorruptSConsignWarning, "Ignoring corrupt .sconsign file: %s"%filename)
SCons.dblite.ignore_corrupt_dbfiles = 1
SCons.dblite.corruption_warning = corrupt_dblite_warning
sig_files = []
DataBase = {}
DB_Module = SCons.dblite
DB_Name = ".sconsign"
DB_sync_list = []
def Get_DataBase(dir):
    global DataBase, DB_Module, DB_Name
    top = dir.fs.Top
    if not os.path.isabs(DB_Name) and top.repositories:
        mode = "c"
        for d in [top] + top.repositories:
            if dir.is_under(d):
                try:
                    return DataBase[d], mode
                except KeyError:
                    path = d.entry_abspath(DB_Name)
                    try: db = DataBase[d] = DB_Module.open(path, mode)
                    except (IOError, OSError): pass
                    else:
                        if mode != "r":
                            DB_sync_list.append(db)
                        return db, mode
            mode = "r"
    try:
        return DataBase[top], "c"
    except KeyError:
        db = DataBase[top] = DB_Module.open(DB_Name, "c")
        DB_sync_list.append(db)
        return db, "c"
    except TypeError:
        print "DataBase =", DataBase
        raise
def Reset():
    global sig_files, DB_sync_list
    sig_files = []
    DB_sync_list = []
normcase = os.path.normcase
def write():
    global sig_files
    for sig_file in sig_files:
        sig_file.write(sync=0)
    for db in DB_sync_list:
        try:
            syncmethod = db.sync
        except AttributeError:
            pass
        else:
            syncmethod()
class Base:
    def __init__(self, module=None):
        self.module = module or SCons.Sig.default_calc.module
        self.entries = {}
        self.dirty = 0
    def get_entry(self, filename):
        return self.entries[filename]
    def set_entry(self, filename, obj):
        self.entries[filename] = obj
        self.dirty = 1
    def do_not_set_entry(self, filename, obj):
        pass
class DB(Base):
    def __init__(self, dir, module=None):
        Base.__init__(self, module)
        self.dir = dir
        db, mode = Get_DataBase(dir)
        path = normcase(dir.tpath)
        try:
            rawentries = db[path]
        except KeyError:
            pass
        else:
            try:
                self.entries = cPickle.loads(rawentries)
                if type(self.entries) is not type({}):
                    self.entries = {}
                    raise TypeError
            except KeyboardInterrupt:
                raise
            except Exception, e:
                SCons.Warnings.warn(SCons.Warnings.CorruptSConsignWarning, "Ignoring corrupt sconsign entry : %s (%s)\n"%(self.dir.tpath, e))
            for key, entry in self.entries.items():
                entry.convert_from_sconsign(dir, key)
        if mode == "r": self.set_entry = self.do_not_set_entry
        global sig_files
        sig_files.append(self)
    def write(self, sync=1):
        if not self.dirty: return
        db, mode = Get_DataBase(self.dir)
        path = normcase(self.dir.path)
        for key, entry in self.entries.items(): entry.convert_to_sconsign()
        db[path] = cPickle.dumps(self.entries, 1)
        if sync:
            try:
                syncmethod = db.sync
            except AttributeError:
                pass
            else:
                syncmethod()

class Dir(Base):
    def __init__(self, fp=None, module=None):
        Base.__init__(self, module)
        if fp:
            self.entries = cPickle.load(fp)
            if type(self.entries) is not type({}):
                self.entries = {}
                raise TypeError

class DirFile(Dir):
    def __init__(self, dir, module=None):
        self.dir = dir
        self.sconsign = os.path.join(dir.path, '.sconsign')
        try:
            fp = open(self.sconsign, 'rb')
        except IOError:
            fp = None

        try:
            Dir.__init__(self, fp, module)
        except KeyboardInterrupt:
            raise
        except:
            SCons.Warnings.warn(SCons.Warnings.CorruptSConsignWarning, "Ignoring corrupt .sconsign file: %s"%self.sconsign)
        global sig_files
        sig_files.append(self)
    def get_entry(self, filename):
        entry = Dir.get_entry(self, filename)
        entry.convert_from_sconsign(self.dir, filename)
        return entry
    def write(self, sync=1):
        if self.dirty:
            temp = os.path.join(self.dir.path, '.scons%d' % os.getpid())
            try:
                file = open(temp, 'wb')
                fname = temp
            except IOError:
                try:
                    file = open(self.sconsign, 'wb')
                    fname = self.sconsign
                except IOError:
                    return
            for key, entry in self.entries.items():
                entry.convert_to_sconsign()
            cPickle.dump(self.entries, file, 1)
            file.close()
            if fname != self.sconsign:
                try:
                    mode = os.stat(self.sconsign)[0]
                    os.chmod(self.sconsign, 0666)
                    os.unlink(self.sconsign)
                except (IOError, OSError):
                    pass
                try:
                    os.rename(fname, self.sconsign)
                except OSError:
                    open(self.sconsign, 'wb').write(open(fname, 'rb').read())
                    os.chmod(self.sconsign, mode)
            try:
                os.unlink(temp)
            except (IOError, OSError):
                pass
ForDirectory = DB
def File(name, dbm_module=None):
    global ForDirectory, DB_Name, DB_Module
    if name is None:
        ForDirectory = DirFile
        DB_Module = None
    else:
        ForDirectory = DB
        DB_Name = name
        if not dbm_module is None:
            DB_Module = dbm_module
