__revision__ = "/home/scons/scons/branch.0/branch.96/baseline/src/engine/SCons/Scanner/Prog.py 0.96.91.D001 2005/09/08 09:14:36 knight"
import string
import SCons.Node
import SCons.Node.FS
import SCons.Scanner
import SCons.Util
print_find_libs = None
def ProgramScanner(**kw):
    kw['path_function'] = SCons.Scanner.FindPathDirs('LIBPATH')
    ps = apply(SCons.Scanner.Base, [scan, "ProgramScanner"], kw)
    return ps
def scan(node, env, libpath = ()):
    try:
        libs = env['LIBS']
    except KeyError:
        return []
    if SCons.Util.is_String(libs):
        libs = string.split(libs)
    elif SCons.Util.is_List(libs):
        libs = SCons.Util.flatten(libs)
    else:
        libs = [libs]

    try:
        prefix = env['LIBPREFIXES']
        if not SCons.Util.is_List(prefix):
            prefix = [ prefix ]
    except KeyError:
        prefix = [ '' ]

    try:
        suffix = env['LIBSUFFIXES']
        if not SCons.Util.is_List(suffix):
            suffix = [ suffix ]
    except KeyError:
        suffix = [ '' ]

    pairs = []
    for suf in map(env.subst, suffix):
        for pref in map(env.subst, prefix): pairs.append((pref, suf))
    result = []

    if callable(libpath): libpath = libpath()
    
    find_file = SCons.Node.FS.find_file
    adjustixes = SCons.Util.adjustixes
    for lib in libs:
        if SCons.Util.is_String(lib):
            lib = env.subst(lib)
            for pref, suf in pairs:
                l = adjustixes(lib, pref, suf)
                l = find_file(l, libpath, verbose=print_find_libs)
                if l: result.append(l)
        else: result.append(lib)
    return result
